/*
 * netinet/in.h
 */

#ifndef _NETINET_IN_H
#define _NETINET_IN_H

#ifndef __GLIBC__
#include <linux/libc-compat.h>

#undef __UAPI_DEF_IN_ADDR
#undef __UAPI_DEF_IN_IPPROTO
#undef __UAPI_DEF_IN_PKTINFO
#undef __UAPI_DEF_IP_MREQ
#undef __UAPI_DEF_SOCKADDR_IN
#undef __UAPI_DEF_IN_CLASS
#undef __UAPI_DEF_IN6_ADDR
#undef __UAPI_DEF_IN6_ADDR_ALT
#undef __UAPI_DEF_SOCKADDR_IN6
#undef __UAPI_DEF_IPV6_MREQ
#undef __UAPI_DEF_IPPROTO_V6
#undef __UAPI_DEF_IPV6_OPTIONS
#undef __UAPI_DEF_IN6_PKTINFO
#undef __UAPI_DEF_IP6_MTUINFO
#undef __UAPI_DEF_IF_IFREQ

#define __UAPI_DEF_IN_ADDR      1
#define __UAPI_DEF_IN_IPPROTO   1
#define __UAPI_DEF_IN_PKTINFO   1
#define __UAPI_DEF_IP_MREQ      1
#define __UAPI_DEF_SOCKADDR_IN  1
#define __UAPI_DEF_IN_CLASS     1
#define __UAPI_DEF_IN6_ADDR     1
#define __UAPI_DEF_IN6_ADDR_ALT 1
#define __UAPI_DEF_SOCKADDR_IN6 1
#define __UAPI_DEF_IPV6_MREQ    1
#define __UAPI_DEF_IPPROTO_V6   1
#define __UAPI_DEF_IPV6_OPTIONS 1
#define __UAPI_DEF_IN6_PKTINFO  1
#define __UAPI_DEF_IP6_MTUINFO  1
#define __UAPI_DEF_IF_IFREQ     1
#endif

#include <sys/types.h>
#include <klibc/extern.h>
#include <stdint.h>
#include <endian.h>		/* Must be included *before* <linux/in.h> */
#include <sys/socket.h>		/* Must be included *before* <linux/in.h> */
#include <linux/in.h>

#ifndef htons
# define htons(x)	__cpu_to_be16(x)
#endif
#ifndef ntohs
# define ntohs(x)	__be16_to_cpu(x)
#endif
#ifndef htonl
# define htonl(x)	__cpu_to_be32(x)
#endif
#ifndef ntohl
# define ntohl(x)	__be32_to_cpu(x)
#endif
#ifndef htonq
# define htonq(x)	__cpu_to_be64(x)
#endif
#ifndef ntohq
# define ntohq(x)	__be64_to_cpu(x)
#endif

#define IPPORT_RESERVED	1024

__extern int bindresvport(int sd, struct sockaddr_in *sin);

#endif				/* _NETINET_IN_H */
